#ifndef BASEMODULE_H
#define BASEMODULE_H

#include <zeitgeist/leaf.h>
#include <zeitgeist/class.h>
#include <zeitgeist/zeitgeist.h>
#include <string>
#include <list>

using namespace std;
using namespace boost;
using namespace zeitgeist;

//static shared_ptr<CoreContext> __g_CoreContext;

//-----------------------------------------------------------------------------
//	CBaseModule class
//-----------------------------------------------------------------------------

class BaseModule : public zeitgeist::Leaf
{
protected:

public: 
	BaseModule();
	virtual ~BaseModule();

	virtual	void	Init();
	virtual void	UnInit();	
};
DECLARE_CLASS(BaseModule);

//-----------------------------------------------------------------------------
//	CBaseISModule class
//-----------------------------------------------------------------------------

class BaseISModule : public BaseModule
{
protected:
	int		mLastTimeStamp;
	
public:
	BaseISModule();
	virtual ~BaseISModule();

	int		GetTimeStamp()			{ return mLastTimeStamp; }

	virtual bool	DataChanged(int TimeStamp);
};
DECLARE_CLASS(BaseISModule);

//-----------------------------------------------------------------------------
//	CBaseBehaviorModule class
//-----------------------------------------------------------------------------

class BaseBehaviourModule : public BaseModule
{
protected:

public:
	BaseBehaviourModule();
	virtual ~BaseBehaviourModule();
};
DECLARE_CLASS(BaseBehaviourModule);

//-----------------------------------------------------------------------------
//	Usage macros
//-----------------------------------------------------------------------------
#define USE_MODULE(name, path) shared_ptr<name> Get##name() { \
        shared_ptr<name> node = shared_dynamic_cast<name> (GetCore()->Get(path)); \
        if (node.get() == 0) { \
                cout << "Could not find " << #name << " on path " << path << endl; \
        } \
        return node; \
}

#endif
