#ifndef IS_MODULE_HANDLER_H
#define IS_MODULE_HANDLER_H

#include <zeitgeist/leaf.h>
#include <zeitgeist/class.h>
#include <string>
#include <list>

#include "BaseModule.h"

class Edge
{
public:
	Edge(): 
		SourceIndex(-1), 
		DestIndex(-1)		
			{};
	Edge(const Edge &c): 
		SourceIndex(c.SourceIndex), 
		DestIndex(c.DestIndex)
			{};
	
	Edge &operator = (const Edge &c)
			{
				SourceIndex = c.SourceIndex;
				DestIndex = c.DestIndex;

				return *this;
			}

	int		SourceIndex;
	int		DestIndex;
};

#define		IS_MODULE_LIST		list<BaseISModule *>
#define		EDGE_LIST		list<Edge>
#define		INT_LIST		list<int>

//-----------------------------------------------------------------------------
//	CISModuleHandler class
//-----------------------------------------------------------------------------

class ISModuleHandler : public zeitgeist::Leaf
{
protected:
	IS_MODULE_LIST	mISModules;
	EDGE_LIST	mEdges;
	INT_LIST	mNotifyOrder;

	int		FindModuleIndex(BaseISModule *Module);
	bool		IsModuleOrdered(int ModuleIndex);
	
public:
	ISModuleHandler();
	virtual ~ISModuleHandler();

	bool	SortModules();

	bool	InsertModule(BaseISModule *Module);
	bool	InsertDependency(BaseISModule *Parent, BaseISModule *Child);

	void	NotifyModules(int TimeStamp);

	void	Vypis();
};

DECLARE_CLASS(ISModuleHandler);

#endif
