#include "PrimaryISModule.h"

using namespace zeitgeist;
using namespace std;
using namespace boost;
using namespace salt;


void
PrimaryISModule::PrintAllStructs()
{
	cout << "PlayingField " << endl;
	cout << "mFieldLength: " << mField.mFieldLength << endl;
	cout << "mFieldWidth: " << mField.mFieldWidth << endl;
	cout << "mFieldHeight: " << mField.mFieldHeight << endl;
	cout << "mGoalWidth: " << mField.mGoalWidth << endl;
	cout << "mGoalDepth: " << mField.mGoalDepth << endl;
	cout << "mGoalHeight: " << mField.mGoalHeight << endl;
	cout << "mBorderSize: " << mField.mBorderSize << endl << endl;

	cout << "Agent " << endl ;
	cout << "mAgentMass: " << mAgent.mAgentMass << endl;
	cout << "mAgentRadius: " << mAgent.mAgentRadius << endl;
	cout << "mAgentMaxSpeed: " << mAgent.mAgentMaxSpeed << endl << endl;
	
	cout << "Ball " << endl;
	cout << "mBallRadius: " << mBall.mBallRadius << endl;
	cout << "distance: "  << mBall.mDistance << endl;
	cout << "theta: "  << mBall.mTheta << endl;
	cout << "phi: "  << mBall.mPhi << endl;
	cout << "mBallMass: " << mBall.mBallMass << endl << endl;
	
	cout << "TeamInfo " << endl;
	cout << "mTeamName: " << mTeamInfo.mTeamName << endl;
	cout << "mOppTeamName: " << mTeamInfo.mOppTeamName << endl;	
	cout << "mTeamIndex: " << mTeamInfo.mTeamIndex << endl;
	cout << "mTeamUnum: " << mTeamInfo.mTeamUnum << endl << endl;
	
	cout << "NonMovableObjects " << endl;
	cout << "mL1Distance: " << mNonMovableObjects.mL1Distance << endl;
	cout << "mL1Theta: " << mNonMovableObjects.mL1Theta << endl;	
	cout << "mL1Phi: " << mNonMovableObjects.mL1Phi << endl << endl;	
	
	cout << "player abs pos: "<< ComputePlayerAbsPosition() << endl;
	cout << "L1: " << ComputeAbsPositionOf1L() << endl;
	
	

}

Vector3f
PrimaryISModule::ComputePlayerAbsPosition(){
	
	// vzdialenost hraca voci bodu L1
	float xPosL1 = (cos (mNonMovableObjects.mL1Theta*PI/180)) * mNonMovableObjects.mL1Distance;
	float yPosL1 = (sin (mNonMovableObjects.mL1Theta*PI/180)) * mNonMovableObjects.mL1Distance;
	
	// vzdialenost hraca voci stredu (0,0)
	// L1 ma suradnice - (dlzka ihriska/2 , sirka ihriska/2)
	
	float xPos = (mField.mFieldLength/2) - xPosL1;
	float yPos = (mField.mFieldWidth/2) - yPosL1;
	
	//cout << "absolutna pozicia tohto hraca:: (x,y) = (" << xPos << ", " << yPos << ")" << endl;
	return Vector3f(xPos, yPos, 0);
}

Vector3f
PrimaryISModule::ComputeAbsPositionOfObject(Vector3f playerAbsPosition, float distance, float theta){
        
		float xPlayerPos;
        float yPlayerPos;

		float xPosition = playerAbsPosition[0] + distance*(cos(theta*PI/180));
        float yPosition = playerAbsPosition[1] + distance*(sin(theta*PI/180));

		return Vector3f(xPosition, yPosition, 0);
}


Vector3f 
PrimaryISModule::ComputeAbsPositionOf1L(){
		
		float xPosition;
		float yPosition;
		xPosition = mField.mFieldLength/2;
		yPosition = mField.mFieldWidth/2;

		return Vector3f(xPosition, yPosition, 0);
}

Vector3f 
PrimaryISModule::ComputeAbsPositionOf1R(){
		
		float xPosition;
		float yPosition;
		xPosition = (-1)*(mField.mFieldLength/2);
		yPosition = mField.mFieldWidth/2;

		return Vector3f(xPosition, yPosition, 0);
}

Vector3f 
PrimaryISModule::ComputeAbsPositionOf2L(){
		
		float xPosition;
		float yPosition;
		xPosition = mField.mFieldLength/2;
		yPosition = (-1)*(mField.mFieldWidth/2);

		return Vector3f(xPosition, yPosition, 0);
}

Vector3f 
PrimaryISModule::ComputeAbsPositionOf2R(){
		
		float xPosition;
		float yPosition;
		xPosition = (-1)*(mField.mFieldLength/2);
		yPosition = (-1)*(mField.mFieldWidth/2);

		return Vector3f(xPosition, yPosition, 0);
}


Vector3f 
PrimaryISModule::ComputeAbsPositionOfGoal1L(){
		
		float xPosition;
		float yPosition;
		xPosition = mField.mFieldLength/2;
		yPosition = mField.mGoalWidth/2;

		return Vector3f(xPosition, yPosition, 0);
}

Vector3f 
PrimaryISModule::ComputeAbsPositionOfGoal2L(){
		
		float xPosition;
		float yPosition;
		xPosition = mField.mFieldLength/2;
		yPosition = (-1)*(mField.mGoalWidth/2);

		return Vector3f(xPosition, yPosition, 0);
}


Vector3f 
PrimaryISModule::ComputeAbsPositionOfGoal1R(){
		
		float xPosition;
		float yPosition;
		xPosition = (-1)*(mField.mFieldLength/2);
		yPosition = mField.mGoalWidth/2;

		return Vector3f(xPosition, yPosition, 0);
}

Vector3f 
PrimaryISModule::ComputeAbsPositionOfGoal2R(){
		
		float xPosition;
		float yPosition;
		xPosition = (-1)*(mField.mFieldLength/2);
		yPosition = (-1)*(mField.mGoalWidth/2);

		return Vector3f(xPosition, yPosition, 0);
}

void 
PrimaryISModule::SetTeamName(std::string input)
{
    mTeamInfo.mTeamName = input;
}

void
PrimaryISModule::OnLink()
{
	mISModuleHandler = shared_dynamic_cast<ISModuleHandler> (GetCore()->Get("/Agent/Sys/ISModuleHandler"));
	if (mISModuleHandler.get() == 0)
        {
            // ak sa dostane sem, vznikla chyba pri inicializacii
	    printf("PrimaryISModule::OnLink() : neni ISModuleHandler\n");
        }
	
	mISModuleHandler->InsertModule(this); // registrujem modul	
}

void
PrimaryISModule::OnUnLink()
{
	mISModuleHandler.reset();
}

bool
PrimaryISModule::DataChanged(int TimeStamp)
{
	return true;
}

