/*
2L	1L
---------
|	|	 /\  vztazna os (X)
|	|	 ||
|	|	 ||
|	|	 ||	
|	|
|	|
|*	|
---------
2R	1R

* - hrac


osX
^
|
|--> osY


Msg from server: S157 167 
(Vision 

(Flag (id 1_l) (pol 126.902 32.8919 -0.100771)) 
(Flag (id 2_l) (pol 106.604 -1.65832 -0.119957)) 
(Flag (id 1_r) (pol 68.9168 90.3665 -0.185547)) 
(Flag (id 2_r) (pol 3.12431 -98.1318 -4.09619)) 

(Goal (id 1_l) (pol 112.662 18.9441 -0.113509)) 
(Goal (id 2_l) (pol 110.502 15.3519 -0.115722)) 
(Goal (id 1_r) (pol 36.5783 90.6905 -0.349588)) 
(Goal (id 2_r) (pol 29.2592 90.8633 -0.437035)) 
*/


#ifndef PRIMARYISMODULE_H
#define PRIMARYISMODULE_H

#include <zeitgeist/leaf.h>
#include <zeitgeist/class.h>
#include <zeitgeist/zeitgeist.h>
#include <soccer/soccertypes.h>
#include <string>
#include <list> 
#include <math.h>
#include "base_classes/BaseModule.h"
#include "base_classes/ISModuleHandler.h"

#define PI 3.14159265

using namespace std;
using namespace boost;
using namespace zeitgeist;
using namespace salt;

struct PlayingField
{
    // soccer variables
    float mFieldLength;
    float mFieldWidth;
    float mFieldHeight;
    float mGoalWidth;
    float mGoalDepth;
    float mGoalHeight;
    float mBorderSize;
    
    //PlayingField() : /*mFieldLength(105.0),*/mFieldLength(10.0), mFieldWidth(68.0), mFieldHeight(20.0), mGoalWidth(7.32), mGoalDepth(2.0), mGoalHeight(2.44), mBorderSize(4.0f) {};
};

struct Agent
{
    // agent parameter
    float mAgentMass;
    float mAgentRadius;
    float mAgentMaxSpeed;
    
    //Agent() : mAgentMass(75), mAgentRadius(0.22), mAgentMaxSpeed(10) {};
};

struct Ball
{
    // ball parameters
    float mDistance;		// relativna pozicia lopty 
    float mTheta;
    float mPhi;
    
    float mBallRadius;
    float mBallMass;
    
    //Ball() : mBallRadius(0.111), mBallMass(0.4) {};
};

struct TeamInfo
{
    // team information
    TTeamIndex mTeamIndex;
    unsigned int mTeamUnum;
    std::string mTeamName;
    std::string mOppTeamName;
    //TeamInfo() : mTeamIndex(TI_NONE), mTeamUnum(0) {}; 
};

struct PolPlayer
{
    string team;	//meno timu hraca
    int id;		//cislo hraca v ramci timu
    double distance; 	//vzdialenost od hraca
    double phi;		//horizontalny uhol
    double theta;	//vertikalny uhol
};

// nehybajuce sa body na inhrisku - rohove vlajky, brankove tyce
struct NonMovableObjects
{
    // relativne pozicie bodu L1 - lavy roh hriska
    float mL1Distance; 	
    float mL1Theta;
    float mL1Phi; 
    
};

class PrimaryISModule : public BaseISModule
{
private:

	shared_ptr<ISModuleHandler> mISModuleHandler;	

public:
	void PrintAllStructs();		// debuggovaci vypis do app/simulator/Logfiles/ -- stdout (len nasi hraci)
	void SetTeamName(std::string);
	Vector3f ComputePlayerAbsPosition(); // pomocou NonMovableObjects-L1 zisti absolutnu polohu hraca voci stredu ihriska
	
	// 19-04-06 Matell, vypocita absolutnu poziciu objektu, ktory je voci hracovi vzdialeny o distance pod uhlom theta 
	Vector3f ComputeAbsPositionOfObject(Vector3f playerAbsPosition, float distance, float theta);
	
	// 19-04-06 Matell, absolutne pozicie nahybnych bodov na ihrisku - rohove vlajky a brankove tyce
	// pocita to z PlayingField udajov o ihrisku
	Vector3f ComputeAbsPositionOf1L();
	Vector3f ComputeAbsPositionOf1R();
	Vector3f ComputeAbsPositionOf2L();
	Vector3f ComputeAbsPositionOf2R();

	Vector3f ComputeAbsPositionOfGoal1L();
	Vector3f ComputeAbsPositionOfGoal2L();
	Vector3f ComputeAbsPositionOfGoal1R();
	Vector3f ComputeAbsPositionOfGoal2R();

	// 3.4.2006 aldur,matell
    	PlayingField mField;
	Agent mAgent;
	Ball mBall;
	TeamInfo mTeamInfo;
	NonMovableObjects mNonMovableObjects;
	TPlayMode mPlayMode; 	 	// skopirovany playmode z parseru

	std::vector<PolPlayer> players;

	void OnLink();
	void OnUnLink();
	bool DataChanged(int TimeStamp);

	//PolPlayer friends[11];
	//PolPlayer enemies[11];
	
};

DECLARE_CLASS(PrimaryISModule);

#endif
