#include "history.h"

using namespace zeitgeist;
using namespace std;
using namespace boost;
using namespace salt; 


void 
History::OnLink()
{
    mISModuleHandler = shared_dynamic_cast<ISModuleHandler> (GetCore()->Get("/Agent/Sys/ISModuleHandler"));
    if(mISModuleHandler.get() == 0)
    {
	//vznikla chyba pri inicializacii
	cout << "History::OnLink nedostupny ISModuleHandler" << endl; 
    }
    
    if(!mISModuleHandler->InsertModule(this))
    {
	//nepodarilo sa zaregistrovat modul v ISModuleHandleri
	cout << "History::OnLink Modul History nie je redistrovany v ISModuleHandleri" << endl; 
    }
    
    mPrimaryISModule = shared_dynamic_cast<PrimaryISModule> (GetCore()->Get("/Agent/Sys/PrimaryISModule"));
    if(mPrimaryISModule.get() == 0)
    {
	//vznikla chyba pri inicializacii
	cout << "History::OnLink nedostupny PrimaryISModule" << endl; 
    }

    if(!mISModuleHandler->InsertDependency(mPrimaryISModule.get(),this))
    {
	//nepodarilo sa zaregistrovat zavislost medzi modulmi
	cout << "History::OnLink Nie je registrovana zavislost na PrimaryISModule" << endl;
    }
}

void
History::OnUnLink()
{
    mPrimaryISModule.reset();
    mISModuleHandler.reset();
}

History::History() : history_length(20)
{}

WorldModel
History::CreateWorldModel()
{
    WorldModel tmp;
    tmp.myself.valid = true;
    tmp.myself.mPosition = mPrimaryISModule->ComputePlayerAbsPosition();
    
    tmp.ball.valid = true;
    tmp.ball.mPosition = mPrimaryISModule->ComputeAbsPositionOfObject(tmp.myself.mPosition,mPrimaryISModule->mBall.mDistance,mPrimaryISModule->mBall.mTheta);
    
    int a = 0; 
    
    for(a = 0; a < 11; a++)
	tmp.friends[a].valid = tmp.enemies[a].valid = false;
    
    string ourTeam = mPrimaryISModule->mTeamInfo.mTeamName;
    for(a = 0; a < mPrimaryISModule->players.size(); a++)
    {
	PolPlayer pol = mPrimaryISModule->players[a];
	
	if(pol.team == ourTeam)
	{
			cout << "Adding friend Team:" << pol.team << endl;
	    tmp.friends[pol.id - 1].valid = true;
	    tmp.friends[pol.id - 1].mPosition = mPrimaryISModule->ComputeAbsPositionOfObject(tmp.myself.mPosition,pol.distance,pol.theta); 
	}
	else
	{
			cout << "Adding enemy Team:" << pol.team << endl;
	    tmp.enemies[pol.id - 1].valid = true;
	    tmp.enemies[pol.id - 1].mPosition = mPrimaryISModule->ComputeAbsPositionOfObject(tmp.myself.mPosition,pol.distance,pol.theta); 
	}
	    
	
    }
    
    tmp.playMode = mPrimaryISModule->mPlayMode;
    
    return tmp;
}

bool
History::DataChanged(int TimeStamp)
{
    WorldModel mdl = CreateWorldModel();
    history.insert(history.begin(),mdl);
    
    if(history.size() > history_length)
    	history.erase(history.end());

    cout << "History update at: " << TimeStamp  << " History length:" << history.size() << endl;

    return true;
}

WorldModel
History::GetData(int index = 0)
{
    if (index > history_length - 1)
	return history[history_length-1];
    else
	return history[index]; 
}