#ifndef INVOKER_H
#define INVOKER_H

#include <sstream>
#include <zeitgeist/zeitgeist.h>
#include <oxygen/oxygen.h>
#include <soccer/soccertypes.h>

using namespace zeitgeist;
using namespace std;
using namespace boost;
using namespace oxygen;
using namespace salt;

#include "commserver.h"
#include "wrapper/wrapper.h"
#include "parser/parser.h"
#include "base_classes/BaseModule.h"
#include "base_classes/ISModuleHandler.h"
#include "base_classes/ISModules/PrimaryISModule.h"
#include "base_classes/ISModules/history.h"
#include "player.h"

class Invoker
{
	public:
		Invoker(Zeitgeist *zg);
		~Invoker();

		void	Run();

		bool	IsInitialized()		{ return mInitialized; }

	private:

		Zeitgeist			* mZeitgeist;

		shared_ptr<CommServer>		mCommServer;
		shared_ptr<Parser>		mParser;
		shared_ptr<Wrapper>		mWrapper;
		shared_ptr<ISModuleHandler>	mISModuleHandler;
		
		shared_ptr<PrimaryISModule>	mPrimaryISModule;
		shared_ptr<History>		mHistory;
		shared_ptr<Player>		mPlayer;

		bool				mInitialized;

		void Init();
};

#endif // INVOKER_H
