#ifndef PLAYER_H
#define PLAYER_H

#include <zeitgeist/leaf.h>
#include <zeitgeist/class.h>

#include "base_classes/BaseModule.h"

#include "parser/parser.h"
#include "wrapper/wrapper.h"

//using namespace zeitgeist;

class Player : public BaseBehaviourModule
{
protected:
    string			mTeamName;

    shared_ptr<Parser>		mParser;
    shared_ptr<Wrapper>		mWrapper;

public:
	Player();
	~Player();
	
	void setTeamName(string teamName)	{ mTeamName = teamName; }
	string getTeamName()			{ return mTeamName; }
	
	virtual void OnLink();
	virtual void OnUnlink();
	
	virtual void Behave();
};
DECLARE_CLASS(Player)

#endif // PLAYER_H
