#include "wrapper.h"

using namespace zeitgeist;
using namespace std;
using namespace boost;
using namespace oxygen;
using namespace salt;

Wrapper::Wrapper()
{	
}

Wrapper::~Wrapper()
{
}

void Wrapper::DoneThinkingMessage()
{
    stringstream ss;
    ss << "D";
    mComm->PutOutput(ss.str().c_str());
}

void Wrapper::DoneInitMessage()
{
    stringstream ss;
    ss << "I";
    mComm->PutOutput(ss.str().c_str());
}

void Wrapper::CreateAgent()
{
    mComm->PutOutput("A(create)");
}

void Wrapper::InitAgent(std::string teamUnum, std::string teamName)
{
    stringstream ss;
    ss << "A(init (unum " << teamUnum << ") (teamname " << teamName << "))";
    mComm->PutOutput(ss.str().c_str());
}

void Wrapper::Beam(const salt::Vector3f& position)
{
    stringstream ss;
    ss << "A(beam "
       << " " << position[0]
       << " " << position[1]
       << "  " << position[2]
       << ")\n";

    mComm->PutOutput(ss.str());
}

void Wrapper::Drive(const salt::Vector3f& driveVec)
{
    stringstream ss;
    ss << "A(drive"
       << " " << driveVec[0]
       << " " << driveVec[1]
       << "  " << driveVec[2]
       << ")";

    mComm->PutOutput(ss.str());
}

void Wrapper::Kick(const float angle, const float power)
{
    stringstream ss;
    ss << "A(kick " << angle << " " << power << ")";

    mComm->PutOutput(ss.str());
}

// inicializacia Commserveru
void Wrapper::OnLink()
{
    mComm = shared_dynamic_cast<CommServer> (GetCore()->Get("/Agent/Sys/CommServer"));
    if (mComm.get() == 0)
        {
            // ak sa dostane sem, vznikla chyba pri inicializacii
	    printf("Wrapper::OnLink() : neni commserver\n");
        }
}

void Wrapper::OnUnlink()
{
    mComm.reset();
}
