#include "run_to_ball_behaviour.h"

// advanced run to ball (cik-cak)
// urobi spojnicu brany a lopty
// a optimalna pozicia na kop je vo nejakej vzdialenosti D "za"
// loptou na tejto spojnici

void RunToBallBehaviour::Behave()
{
    WorldModel world = GetHistory()->history[0];
    Vector3f ballPos = world.ball.mPosition;
    AbsPlayer myself = world.myself;
		
	  Vector3f goal(GetHistory()->myField.mFieldLength/2,0,0);
		
		double triX = abs(ballPos[0] - goal[0]);
		double triY = abs(ballPos[1] - goal[1]);
		
		// toto je ta vzdialenost "za" loptou
		// problem je mozno v sume -ked je prilis daleko od brany, tak to nestaci
		// normalne mozno kopat do lopty az pri 0.04, ale hrac ma este zotrovacnost
		double d = GetHistory()->agentParameters.mAgentRadius + GetHistory()->ballParameters.mBallRadius + 0.5;

		// z podobnosti trojuholnikov si vypocita bod, na ktory sa ma presunut
		double triZ = sqrt(triX*triX + triY*triY);
		
		double Xd = (d*triX)/(triZ);
		double Yd = (d*triY)/(triZ);
		
		Vector3f bestPosition(0,0,0);
		
		// zalezi od toho, ci je lopta na lavej alebo pravej strane ihriska
		if(ballPos[1]<0)
			bestPosition = Vector3f(ballPos[0] - Xd, ballPos[1] - Yd, 0);
		else 
		  bestPosition = Vector3f(ballPos[0] - Xd,ballPos[1] + Yd, 0);
			
		Vector3f kickDriveLine = (bestPosition - myself.mPosition);
		float kickPosDist = kickDriveLine.Length();
		
		// teraz by sa mal nachadzat v bode, ktory je priamke spajajucej loptu a branu
		if(kickPosDist<0.5){
    	kickDriveLine = Vector3f(ballPos - myself.mPosition);
			kickDriveLine *= 15;
    	GetWrapper()->Drive(kickDriveLine);
		} 
		
		// ked je uz blizsie k lopte, trochu spomali
		else if(kickPosDist<1){
			kickDriveLine *= 50;
    	GetWrapper()->Drive(kickDriveLine);
		}  
		// ked je uplne daleko od lopty, bezi naplno na poziciu "za" loptou
		else {
		  kickDriveLine *= 100;
    	GetWrapper()->Drive(kickDriveLine);
		}
		
		
	
}
