#include <sstream>
#include <zeitgeist/zeitgeist.h>
#include <oxygen/oxygen.h>
#include <soccer/soccertypes.h>

#include "base_classes/invoker.h"
#include "hazard_player/hazard_player.h"

using namespace zeitgeist;

#define REGISTER_MODULE(_module) zg.GetCore()->RegisterClassObject(new CLASS(_module), "");

int main()
{
    Zeitgeist zg("." PACKAGE_NAME);

    REGISTER_MODULE(KickBallBehaviour)
    REGISTER_MODULE(HandleBallBehaviour)
    REGISTER_MODULE(ReturnToPositionBehaviour)
    REGISTER_MODULE(RunToBallBehaviour)
    REGISTER_MODULE(HoldPositionBehaviour)
    REGISTER_MODULE(History)
    REGISTER_MODULE(Formation)
    REGISTER_MODULE(HazardPlayer)
    
    Invoker	playerInvoker(&zg);
    if (!playerInvoker.IsInitialized())	return 1;

    playerInvoker.Run();
    return 0;
}
